/*
 * ----------------------------------------------------------------
 * Night Light IRC Proxy - Configuration Header
 * ----------------------------------------------------------------
 * Copyright (C) 2006-2007 Jonas Kvinge <jonas@night-light.net>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Last modified by:
 * Jonas Kvinge (15.11.2006)
 *
 */

#ifdef CONF_H
#warning "conf.h already included."
#else
#define CONF_H

#define CONF_CONFFILE					"ircproxyd.conf"
#define CONF_CHDIR					0
#define CONF_CHDIRPATH					"."
#define CONF_PIDFILE					"/var/run/ircproxyd.pid"
#define CONF_EUSER					"ircproxy"
#define CONF_EGROUP					"users"
#define CONF_DATAPATH					"/usr/share/ircproxy"
#define CONF_LOGPATH					"/var/log"
#define CONF_ACCESS_CONFFILE				"ircproxyd-access.conf"
#define CONF_LISTEN_CONFFILE				"ircproxyd-listen.conf"
#define CONF_USER_CONFFILE				"ircproxyd-user.conf"
#define CONF_CONN_CONFFILE				"ircproxyd-conn.conf"
#define CONF_AUTOOP_CONFFILE				"ircproxyd-autoop.conf"
#define CONF_IDENT_CONFFILE				"ircproxyd-ident.conf"
#define CONF_MAINLOGFILE				"ircproxyd.log"
#define CONF_ERRORLOGFILE				"ircproxyd-error.log"
#define CONF_DEBUGLOGFILE				"ircproxyd-debug.log" 
#define CONF_CRYPTPASS					TRUE
#define CONF_UNIXPASSWD					FALSE
#define CONF_SSLSUPPORT					TRUE
#define CONF_SSLSERVERCERTIFICATE			"ircproxy.crt"
#define CONF_SSLSERVERPRIVATEKEY			"ircproxy.key"
#define CONF_SSLCLIENTCERTIFICATE			"ircproxy.crt"
#define CONF_SSLCLIENTPRIVATEKEY			"ircproxy.key"
#define CONF_SSLSERVERCIPHERS				"NONE"
#define CONF_SSLCLIENTCIPHERS				"NONE"
#define CONF_NAMESERVER					"NONE"
#define CONF_MAXCLIENTS					30
#define CONF_CLIENT_SHOWDENYREASON			TRUE
#define CONF_CLIENT_MAXSENDQ				200
#define CONF_CLIENT_MAXLINES				150
#define CONF_CLIENT_LINEFLOODTTL			10
#define CONF_CLIENT_SEND001				FALSE
#define CONF_CLIENT_SENDMOTD				FALSE

/* STRUCTURES - JONAS (15.11.2006) */

struct Conf_Struct {

  char *File;
  unsigned short int ChDir;
  char *ChDirPath;
  char *PIDFile;
  char *EUser;
  char *EGroup;
  char *DataPath;
  char *LogPath;
  char *AccessConfFile;
  char *ListenConfFile;
  char *UserConfFile;
  char *ConnConfFile;
  char *AutoOPConfFile;
  char *IdentConfFile;
  char *MainLogFile;
  char *ErrorLogFile;
  char *DebugLogFile;
  unsigned short int SSLSupport;
  char *SSLServerCertificate;
  char *SSLClientCertificate;
  char *SSLServerPrivateKey;
  char *SSLClientPrivateKey;
  char *SSLServerCiphers;
  char *SSLClientCiphers;
  unsigned short int CryptPass;
  unsigned short int UnixPasswd;
  char *NameServer;
  unsigned short int MaxClients;
  unsigned short int ClientShowDenyReason;
  unsigned long int ClientMaxSendQ;
  unsigned long int ClientMaxLines;
  unsigned long int ClientLineFloodTTL;
  unsigned short int ClientSend001;
  unsigned short int ClientSendMOTD;

};

/* FUNCTION PROTOTYPES - JONAS (15.11.2006) */

signed long int conf_read(void);
void conf_init(void);
void conf_destroy(void);

#endif
