/*
 * ----------------------------------------------------------------
 * Night Light IRC Proxy Connection Header
 * ----------------------------------------------------------------
 * Copyright (C) 1997-2007 Jonas Kvinge <jonas@night-light.net>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Last modified by:
 * Jonas Kvinge (24.11.2007)
 *
 */

#ifdef CONN_CONNECTION_H
#warning "conn_connection.h already included."
#else
#define CONN_CONNECTION_H

/* FUNCTION PROTOTYPES - JONAS (18.07.2001) */

void conn_initconnection(struct Conn_Struct *ConnS);
void conn_connect(struct Conn_Struct *ConnS);
void conn_disconnect(struct Conn_Struct *ConnS, const char *const LinePT, ...) __attribute__ ((format (printf, 2, 3)));
#if HAVE_CARES_CALLBACK_TIMEOUTS
void conn_hosttoip(void *ArgPT, int ErrNo, int Timeouts, struct hostent *HostEnt);
void conn_serverhosttoip(void *ArgPT, int ErrNo, int Timeouts, struct hostent *HostEnt);
#else
void conn_hosttoip(void *ArgPT, int ErrNo, struct hostent *HostEnt);
void conn_serverhosttoip(void *ArgPT, int ErrNo, struct hostent *HostEnt);
#endif
void conn_logon(struct Conn_Struct *ConnS);
void conn_addsend(struct Conn_Struct *ConnS, const char *const LinePT);
void conn_quit(struct Conn_Struct *ConnS, const char *const MessagePT, ...) __attribute__ ((format (printf, 2, 3)));
unsigned short int conn_closeall(const char *const MessagePT, ...) __attribute__ ((format (printf, 1, 2)));

#endif
