/*
 * ----------------------------------------------------------------
 * Night Light IRC Proxy - Connection Ignore Header
 * ----------------------------------------------------------------
 * Copyright (C) 1997-2003 Jonas Kvinge <jonas@night-light.net>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Last modified by:
 * Jonas Kvinge (18.07.2001)
 *
 */

#ifdef CONN_IGNORE_H
#warning "conn_ignore.h already included."
#else
#define CONN_IGNORE_H

/* STRUCTURES - JONAS (18.07.2001) */

struct Ignore_Struct {

  unsigned short int Type;
  char *NUH;
  time_t ExpireTime;

  struct Ignore_Struct *Prev;
  struct Ignore_Struct *Next;

};

/* FUNCTION PROTOTYPES - JONAS (18.07.2001) */

struct Ignore_Struct *conn_addignore(struct Conn_Struct *ConnS, const char *const NUHPT);
void conn_remignore(struct Conn_Struct *ConnS, struct Ignore_Struct *IgnoreS);
struct Ignore_Struct *conn_getignore(struct Conn_Struct *ConnS, const char *const NUHPT);
void conn_ignoreexpire(struct Conn_Struct *ConnS);
void conn_destroyignores(struct Conn_Struct *ConnS);

#endif
