/*
 * ----------------------------------------------------------------
 * Night Light IRC Proxy - Connection SendQ Header
 * ----------------------------------------------------------------
 * Copyright (C) 1997-2003 Jonas Kvinge <jonas@night-light.net>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Last modified by:
 * Jonas Kvinge (18.07.2001)
 *
 */

#ifdef CONN_SENDQ_H
#warning "conn_sendq.h already included."
#else
#define CONN_SENDQ_H

/* STRUCTURES - JONAS (18.07.2001) */

struct SendQ_Struct {

  char *Line;
  unsigned short int Priority;
  time_t Time;

  struct SendQ_Struct *Next;

};

struct FlushL_Struct {

  unsigned short int Lines;
  time_t Time;

  struct FlushL_Struct *Prev;
  struct FlushL_Struct *Next;

};

struct FlushB_Struct {

  unsigned short int Len;
  time_t Time;

  struct FlushB_Struct *Prev;
  struct FlushB_Struct *Next;

};

/* FUNCTION PROTOTYPES - JONAS (18.07.2001) */

void conn_addsendq(struct Conn_Struct *ConnS, const char *const LinePT, ...) __attribute__ ((format (printf, 2, 3)));
void conn_flushsendq(struct Conn_Struct *ConnS);
void conn_initsendq(struct Conn_Struct *ConnS);

void conn_addflushl(struct Conn_Struct *ConnS, const unsigned short int Lines);
void conn_initflushl(struct Conn_Struct *ConnS);

void conn_addflushb(struct Conn_Struct *ConnS, const unsigned short int Len);
void conn_initflushb(struct Conn_Struct *ConnS);

#endif
