/*
 * ----------------------------------------------------------------
 * Night Light IRC Proxy - Ident Daemon - Configuration Header
 * ----------------------------------------------------------------
 * Copyright (C) 1997-2003 Jonas Kvinge <jonas@night-light.net>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Last modified by:
 * Jonas Kvinge (03.07.2003)
 *
 */

#ifdef IDENT_CONF_H
#warning "ident_conf.h already included."
#else
#define IDENT_CONF_H

/* STRUCTURES - JONAS (03.07.2003) */

struct IdentConf_Struct {

  char *Host;
  unsigned long int Port;
  unsigned short int IPv6;

  struct IdentConf_Struct *Next;
  struct IdentConf_Struct *Prev;

};

/* FUNCTION PROTOTYPES - JONAS (03.07.2003) */

signed long int ident_conf_read(void);
struct IdentConf_Struct *ident_conf_add(const char *const HostPT, const unsigned long int Port, unsigned short int IPv6);
void ident_conf_rem(struct IdentConf_Struct *IdentConf);
struct IdentConf_Struct *ident_conf_get(const char *const HostPT, const unsigned long int Port);
void ident_conf_destroy(void);

#endif
