/*
 * ----------------------------------------------------------------
 * Night Light IRC Proxy Header
 * ----------------------------------------------------------------
 * Copyright (C) 1997-2007 Jonas Kvinge <jonas@night-light.net>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Last modified by:
 * Jonas Kvinge (25.11.2007)
 *
 */

#ifdef IRCPROXY_H
#warning "ircproxy.h already included."
#else
#define IRCPROXY_H

struct hostent;

#define PACKAGE						PACKAGE_NAME
#define VERSION						PACKAGE_VERSION
#define UNIXNAME					PACKAGE
#define SHORTNAME					"Night Light IRC Proxy"
#define LONGNAME					"Night Light Internet Relay Chat Proxy Server Daemon"
#define DESCRIPTION					"Internet Relay Chat Proxy"
#define AUTHORNAME					"Jonas Kvinge"
#define AUTHORMAIL					"jonas@night-light.net"
#define URL						"http://www.ircproxy.night-light.net/"
#define COPYRIGHT					"Copyright (C) 1997-2007 Jonas Kvinge, all rights reserved."
#define STARTUPLN1					SHORTNAME " v" VERSION
#define STARTUPLN2					COPYRIGHT

#define NLPRGSEC					3
#define NLPRGUSEC					0

#define EXITTTL						10
#define FLUSHTIME					45

#ifndef SOMAXCONN
  #define SOMAXCONN 64
#endif

#define IRCP_USER_HOST(X)				(((X->ListenS != NULL) && (X->ListenS->Host != NULL) && (strcmp(X->ListenS->Host, "*") != FALSE) && (strcmp(X->ListenS->Host, "0.0.0.0") != FALSE)) ? X->ListenS->Host : HOSTNAME)
#define IRCP_USER_NICK(X)				(((X->ConnS != NULL) && (Conn_IsWelcome(X->ConnS))) ? X->ConnS->IRCNick : "*")

#ifndef NBLOCK_SYSV
  #ifndef NBLOCK_BSD
    #ifndef NBLOCK_POSIX
      #define NBLOCK_POSIX 1
    #endif
  #endif
#endif

#endif
