/*
 * ----------------------------------------------------------------
 * Night Light IRC Proxy - Listen Configuration Header
 * ----------------------------------------------------------------
 * Copyright (C) 1997-2003 Jonas Kvinge <jonas@night-light.net>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Last modified by:
 * Jonas Kvinge (18.07.2001)
 *
 */

#ifdef LISTEN_CONF_H
#warning "listen_conf.h already included."
#else
#define LISTEN_CONF_H

/* STRUCTURES - JONAS (18.07.2001) */

struct ListenConf_Struct {

  char *Host;
  unsigned long int Port;
  unsigned short int SSL;
  unsigned short int IPv6;

  struct ListenConf_Struct *Next;
  struct ListenConf_Struct *Prev;

};

/* FUNCTION PROTOTYPES - JONAS (18.07.2001) */

signed long int listen_conf_read(void);
struct ListenConf_Struct *listen_conf_add(const char *const HostPT, const unsigned long int Port, const unsigned short int IPv6, const unsigned short int SSL);
void listen_conf_rem(struct ListenConf_Struct *ListenConf);
struct ListenConf_Struct *listen_conf_get(const char *const HostPT, const unsigned long int Port, const unsigned short int IPv6, const unsigned short int SSL);
void listen_conf_destroy(void);

#endif
