/*
 * ----------------------------------------------------------------
 * Night Light IRC Proxy - User Configuration Header
 * ----------------------------------------------------------------
 * Copyright (C) 1997-2007 Jonas Kvinge <jonas@night-light.net>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Last modified by:
 * Jonas Kvinge (24.11.2007)
 *
 */

#ifdef USER_CONF_H
#warning "user_conf.h already included."
#else
#define USER_CONF_H

/* STRUCTURES - JONAS (18.07.2001) */

struct UserConf_Struct {

  char *User;
  char *Pass;

  struct UserConf_Struct *Next;
  struct UserConf_Struct *Prev;

};

/* FUNCTION PROTOTYPES - JONAS (18.07.2001) */

signed long int user_conf_read(void);
struct UserConf_Struct *user_conf_add(const char *const UserPT, const char *const PassPT);
void user_conf_rem(struct UserConf_Struct *UserConf);
struct UserConf_Struct *user_conf_get(const char *const UserPT);
void user_conf_destroy(void);

#endif
